unit MakeLossy;

interface

procedure makeLossySampleBlock(var sampleBlockCh0: array of LongInt; var sampleBlockCh1: array of LongInt; samplesCount: integer);
                                                            // Transforms sampleBlockCh0 and sampleBlockCh1 (in case of stereo)
                                                            // into a lossy version by keeping only the 11 MSBs
                                                            // (setting the other ones to zero).
                                                            // First sample transformed is in element with index 0.
                                                            // Last sample transformed is in element with index samplesCount - 1.

implementation
uses
  wavIO;

function lossySample(sample: LongInt): LongInt;
 begin
  lossySample := sample AND $FFE00000  // all bits except for the 11 MSB set to 0
 end;

procedure makeLossySampleBlock(var sampleBlockCh0: array of LongInt; var sampleBlockCh1: array of LongInt; samplesCount: integer);
var
 i: integer;
 begin
    if channelCount() = 1 then
       for i:= 0 to samplesCount -1 do
           sampleBlockCh0[i] := lossySample(sampleBlockCh0[i])
    else // stereo:
       for i:= 0 to samplesCount -1 do
           begin
           sampleBlockCh0[i] := lossySample(sampleBlockCh0[i]);
           sampleBlockCh1[i] := lossySample(sampleBlockCh1[i]);
           end;
 end;

end.
